package com.nationrel.modules.rp.entity;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.math.BigDecimal;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import lombok.Data;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.jeecg.common.aspect.annotation.Dict;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * @Description: prediction_stru_tree
 * @Author: nationrel
 * @Date: 2024-08-26
 * @Version: V1.0
 */
@Data
@TableName(value = "prediction_stru_tree", autoResultMap = true)
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
@Schema(description="prediction_stru_tree")
public class PredictionStruTree implements Serializable {
    private static final long serialVersionUID = 1L;

	/**主键*/
	@TableId(type = IdType.ASSIGN_ID)
    @Schema(description = "主键")
    private String id;
	/**结构UUID*/
	@Excel(name = "结构UUID", width = 15)
    @Schema(description = "结构UUID")
    private String struId;
	/**预测ID*/
	@Excel(name = "预测ID", width = 15)
    @Schema(description = "预测ID")
    private String predictionId;
	/**父结构ID*/
	@Excel(name = "父结构ID", width = 15)
    @Schema(description = "父结构ID")
    private String parentStruId;
	/**节点类型(默认01)*/
	@Excel(name = "节点类型(默认01)", width = 15)
    @Schema(description = "节点类型(默认01)")
    private String struTypeCode;
	/**序列号*/
	@Excel(name = "序列号", width = 15)
    @Schema(description = "序列号")
    private String seriesNo;
	/**深度*/
	@Excel(name = "深度", width = 15)
    @Schema(description = "深度")
    private Integer deep;
	/**leftNo*/
	@Excel(name = "leftNo", width = 15)
    @Schema(description = "leftNo")
    private Integer leftNo;
	/**rightNo*/
	@Excel(name = "rightNo", width = 15)
    @Schema(description = "rightNo")
    private Integer rightNo;
	/**type*/
	@Excel(name = "type", width = 15)
    @Schema(description = "type")
    private String type;
	/**name*/
	@Excel(name = "name", width = 15)
    @Schema(description = "name")
    private String name;
	/**删除状态--0:未删除 1:已删除*/
	@Excel(name = "删除状态--0:未删除 1:已删除", width = 15)
    @Schema(description = "删除状态--0:未删除 1:已删除")
    private Integer isDelete;
	/**回收站ID*/
	@Excel(name = "回收站ID", width = 15)
    @Schema(description = "回收站ID")
    private String recycleId;
	/**创建者id*/
	@Excel(name = "创建者id")
    @Schema(description = "创建者")
    private String insertUserBy;
	/**创建时间*/
	@Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "创建时间")
    private Date insertTime;
	/**更新者id*/
	@Excel(name = "更新者id")
    @Schema(description = "更新者id")
    private String updateUserBy;
	/**更新时间*/
	@JsonFormat(timezone = "GMT+8",pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Schema(description = "更新时间")
    private Date updateTime;
	/**版本*/
	@Excel(name = "版本", width = 15)
    @Schema(description = "版本")
    private Integer versionNo;
}
