package com.nationrel.modules.rp.service.impl;

import com.nationrel.modules.rp.entity.PredictionInfo;
import com.nationrel.modules.rp.entity.PredictionStruTree;
import com.nationrel.modules.rp.enums.StateEnum;
import com.nationrel.modules.rp.mapper.PredictionInfoMapper;
import com.nationrel.modules.rp.mapper.PredictionStruTreeMapper;
import com.nationrel.modules.rp.service.IPredictionInfoService;
import me.zhyd.oauth.utils.UuidUtils;
import org.apache.commons.lang.math.RandomUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @Description: prediction_info
 * @Author: nationrel
 * @Date:   2024-08-26
 * @Version: V1.0
 */
@Service
public class PredictionInfoServiceImpl extends ServiceImpl<PredictionInfoMapper, PredictionInfo> implements IPredictionInfoService {

    @Autowired
    private PredictionInfoMapper predictionInfoMapper;

    @Autowired
    private PredictionStruTreeMapper predictionStruTreeMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void savePredictionInfo(PredictionInfo predictionInfo) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        predictionInfo.setCreateBy(sysUser.getUsername());
        predictionInfo.setCreateTime(new Date());
        predictionInfo.setRpCode(executeCode());
        predictionInfo.setDelFlag(StateEnum.NOT_DELETE.getValue());
        predictionInfo.setVersionNo(1);
        predictionInfoMapper.insert(predictionInfo);
        String struId = UuidUtils.getUUID();
        PredictionStruTree predictionStruTree = new PredictionStruTree();
        predictionStruTree.setStruId(struId);
        predictionStruTree.setParentStruId("00000000000000000000000000000000");
        predictionStruTree.setPredictionId(predictionInfo.getId());
        predictionStruTree.setStruTypeCode("01");
        predictionStruTree.setSeriesNo("1");
        predictionStruTree.setDeep(1);
        predictionStruTree.setLeftNo(1);
        predictionStruTree.setRightNo(2);
        predictionStruTree.setType("1");
        predictionStruTree.setName(predictionInfo.getRpName());
        predictionStruTree.setInsertTime(new Date());
        predictionStruTree.setInsertUserBy(sysUser.getUsername());
        predictionStruTreeMapper.insert(predictionStruTree);
    }

    @Override
    public void updatePredictionInfo(PredictionInfo predictionInfo) {

    }

    @Override
    public void deletePredictionInfo(PredictionInfo predictionInfo) {

    }


    /**
     * @Description 编码
     * @param
     * @return java.lang.String
     * @Author nijun
     * @Date: 2024/8/26 19:13
     */
    public String executeCode() {
        String prefix = "RP";
        SimpleDateFormat format = new SimpleDateFormat("yyyyMMddHHmmss");
        int random = RandomUtils.nextInt(90) + 10;
        String value = prefix + format.format(new Date()) + random;
        return value;
    }
}
